"use strict";

var ownKeys, __createBinding = this && this.__createBinding || (Object.create ? function(o, m, k, k2) {
    void 0 === k2 && (k2 = k);
    var desc = Object.getOwnPropertyDescriptor(m, k);
    desc && !("get" in desc ? !m.__esModule : desc.writable || desc.configurable) || (desc = {
        enumerable: !0,
        get: function() {
            return m[k];
        }
    }), Object.defineProperty(o, k2, desc);
} : function(o, m, k, k2) {
    void 0 === k2 && (k2 = k), o[k2] = m[k];
}), __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function(o, v) {
    Object.defineProperty(o, "default", {
        enumerable: !0,
        value: v
    });
} : function(o, v) {
    o.default = v;
}), __importStar = this && this.__importStar || (ownKeys = function(o) {
    return ownKeys = Object.getOwnPropertyNames || function(o) {
        var ar = [];
        for (var k in o) Object.prototype.hasOwnProperty.call(o, k) && (ar[ar.length] = k);
        return ar;
    }, ownKeys(o);
}, function(mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (null != mod) for (var k = ownKeys(mod), i = 0; i < k.length; i++) "default" !== k[i] && __createBinding(result, mod, k[i]);
    return __setModuleDefault(result, mod), result;
}), __importDefault = this && this.__importDefault || function(mod) {
    return mod && mod.__esModule ? mod : {
        default: mod
    };
};

Object.defineProperty(exports, "__esModule", {
    value: !0
});

const WebAssemblyRunner_1 = __importDefault(require("@libmedia/cheap/webassembly/WebAssemblyRunner")), logger = __importStar(require("@libmedia/common/util/logger")), errorType = __importStar(require("@libmedia/avutil/error"));

exports.default = class {
    resampler;
    options;
    inputParameters;
    outputParameters;
    constructor(options) {
        this.options = options, this.resampler = new WebAssemblyRunner_1.default(this.options.resource);
    }
    async open(input, output) {
        this.inputParameters = input, this.outputParameters = output, await this.resampler.run(), 
        this.resampler.invoke("resample_set_input_parameters", input.sampleRate, input.channels, input.format, input.layout || 0), 
        this.resampler.invoke("resample_set_output_parameters", output.sampleRate, output.channels, output.format, output.layout || 0);
        let ret = this.resampler.invoke("resample_init");
        return ret < 0 ? (logger.error(`open resampler failed, ret: ${ret}`, "src/audioresample/Resampler.ts", 85), 
        errorType.INVALID_PARAMETERS) : 0;
    }
    resample(input, output, numberOfFrames) {
        return this.resampler.invoke("resample_process", input, output, numberOfFrames);
    }
    getOutputSampleCount(numberOfFrames) {
        return this.resampler.invoke("resample_nb_sample", numberOfFrames);
    }
    close() {
        this.resampler.invoke("resample_destroy"), this.resampler.destroy();
    }
    getInputPCMParameters() {
        return this.inputParameters;
    }
    getOutputPCMParameters() {
        return this.outputParameters;
    }
};
//# sourceMappingURL=Resampler.js.map